local global = _G;

module(...)

global.class = function(base, ctor)
	local c = {};

	if( not ctor and global.type(base) == "function" ) then
		ctor = base;
		base = nil;
	elseif( global.type(base) == 'table' ) then
		for i,v in global.pairs(base) do
			c[i] = v;
		end
		c._base = base;
	end;
	c.__index = c;

	local mt = {};
	mt.__call = function(class_tbl, ...)
		local obj = {};
		global.setmetatable(obj, c);

		if( ctor ) then
			ctor(obj, ...);
		else
			if( base and base.init ) then
				base.init(obj, ...);
			end;
		end;

		return obj;
	end;

	c.init = ctor;
	c.is_a = function(self, _basetype)
  		local m = global.getmetatable(self);

		while( m ) do
			if( m == _basetype ) then
				return true;
			end;

			m = m._base;
		end

		return false;
	end;

	global.setmetatable(c, mt);
	return c;
end
